// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package base

import (
	model "LAPP_LF_MOM_BACKEND/models/base"
	"LAPP_LF_MOM_BACKEND/web/middleware/jwts"
	"LAPP_LF_MOM_BACKEND/web/models"
	"LAPP_LF_MOM_BACKEND/web/supports"
	"github.com/kataras/iris/v12"
	"github.com/kataras/iris/v12/core/router"
)

/******************************************************************************
 *
 * @Function Name            : RegisterOneOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个处理单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : HTTP方法
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterOneOPCMonitorBasicComInfo(party router.Party, httpMethod string, path string, method func(*models.Usertab, *model.OPCMonitorBasicComInfo) error) {

	party.Handle(httpMethod, path, func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		var err error = nil

		entity := new(model.OPCMonitorBasicComInfo)
		if ctx.GetContentLength() > 0 {
			err := ctx.ReadJSON(entity)
			if err != nil {
				supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
				return
			}
		} else {
			entity = nil
		}

		err = method(user, entity)
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, nil)
	})
}

/******************************************************************************
 *
 * @Function Name            : RegisterIDOfOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个通过主键处理单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : HTTP方法
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterIDOfOPCMonitorBasicComInfo(party router.Party, httpMethod string, path string, method func(*models.Usertab, int, int, int, int) error) {

	party.Handle(httpMethod, path, func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		var err error = nil
		workPlaceNr, err := ctx.Params().GetInt("workPlaceNr")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorPalletInPlace, err := ctx.Params().GetInt("monitorPalletInPlace")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorManualRelease, err := ctx.Params().GetInt("monitorManualRelease")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorProblemPieceRelease, err := ctx.Params().GetInt("monitorProblemPieceRelease")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}

		err = method(user, workPlaceNr, monitorPalletInPlace, monitorManualRelease, monitorProblemPieceRelease)
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, nil)
	})
}

/******************************************************************************
 *
 * @Function Name            : RegisterInsertOneOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个插入单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterInsertOneOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *model.OPCMonitorBasicComInfo) error) {

	RegisterOneOPCMonitorBasicComInfo(party, "POST", path, method)
}

/******************************************************************************
 *
 * @Function Name            : RegisterDeleteOneOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个删除单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterDeleteOneOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, int, int, int, int) error) {

	RegisterIDOfOPCMonitorBasicComInfo(party, "DELETE", path+"/{workPlaceNr:int}/{monitorPalletInPlace:int}/{monitorManualRelease:int}/{monitorProblemPieceRelease:int}", method)
}

/******************************************************************************
 *
 * @Function Name            : RegisterSelectOneOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个查找单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterSelectOneOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, int, int, int, int) (*model.OPCMonitorBasicComInfo, error)) {

	party.Get(path+"/{workPlaceNr:int}/{monitorPalletInPlace:int}/{monitorManualRelease:int}/{monitorProblemPieceRelease:int}", func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		workPlaceNr, err := ctx.Params().GetInt("workPlaceNr")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorPalletInPlace, err := ctx.Params().GetInt("monitorPalletInPlace")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorManualRelease, err := ctx.Params().GetInt("monitorManualRelease")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		monitorProblemPieceRelease, err := ctx.Params().GetInt("monitorProblemPieceRelease")
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		result, err := method(user, workPlaceNr, monitorPalletInPlace, monitorManualRelease, monitorProblemPieceRelease)
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		if result == nil {
			supports.Error(ctx, iris.StatusNotFound, supports.NotFound, nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, result)
	})
}

/******************************************************************************
 *
 * @Function Name            : RegisterUpdateOneOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个修改单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterUpdateOneOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *model.OPCMonitorBasicComInfo) error) {

	RegisterOneOPCMonitorBasicComInfo(party, "PUT", path, method)
}

/******************************************************************************
 *
 * @Function Name            : RegisterMultiOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个处理多条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : HTTP方法
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterMultiOPCMonitorBasicComInfo(party router.Party, httpMethod string, path string, method func(*models.Usertab, *[]model.OPCMonitorBasicComInfo) error) {

	party.Handle(httpMethod, path, func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		entities := make([]model.OPCMonitorBasicComInfo, 0, 10)
		err := ctx.ReadJSON(&entities)
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}

		err = method(user, &entities)
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, nil)
	})
}

/******************************************************************************
 *
 * @Function Name            : RegisterInsertOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个插入多条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterInsertOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *[]model.OPCMonitorBasicComInfo) error) {

	RegisterMultiOPCMonitorBasicComInfo(party, "POST", path, method)
}

/******************************************************************************
 *
 * @Function Name            : RegisterDeleteOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个删除多条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterDeleteOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *[]model.OPCMonitorBasicComInfo) error) {

	RegisterMultiOPCMonitorBasicComInfo(party, "DELETE", path, method)
}

/******************************************************************************
 *
 * @Function Name            : RegisterSelectOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个查询OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterSelectOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, map[string]string) (interface{}, error)) {

	party.Get(path, func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		result, err := method(user, ctx.URLParams())
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, result)
	})
}

/******************************************************************************
 *
 * @Function Name            : RegisterUpdateOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个修改多条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-22 15:49:36
 *
 ******************************************************************************/
func RegisterUpdateOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *[]model.OPCMonitorBasicComInfo) error) {

	RegisterMultiOPCMonitorBasicComInfo(party, "PUT", path, method)
}


/******************************************************************************
 *
 * @Function Name            : RegisterSaveOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个插入单条OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : zhangxin
 *
 * @Date                     : 2021-08-23
 *
 ******************************************************************************/
func RegisterSaveOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, *model.OPCMonitorBasicComInfo) error) {

	RegisterOneOPCMonitorBasicComInfo(party, "POST", path, method)
}


/******************************************************************************
 *
 * @Function Name            : RegisterGetRuleOPCMonitorBasicComInfo
 *-----------------------------------------------------------------------------
 *
 * @Description              : 为一个查询OPCMonitorBasicComInfo的方法注册路由
 *
 * @Function Parameters      : 路由分组
 *
 * @Function Parameters      : 路径
 *
 * @Function Parameters      : 实际处理请求的方法
 *
 * @Author                   : zhangxin
 *
 * @Date                     : 2021-08-23
 *
 ******************************************************************************/
func RegisterGetRuleOPCMonitorBasicComInfo(party router.Party, path string, method func(*models.Usertab, map[string]string) (interface{}, error)) {

	party.Get(path, func(ctx iris.Context) {
		user, ok := jwts.ParseToken(ctx)
		if !ok {
			supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
			return
		}

		result, err := method(user, ctx.URLParams())
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
			return
		}
		supports.Ok(ctx, supports.OptionSuccess, result)
	})
}